#ifndef __STRING_L
#define __STRING_L
#include "vec_cl.h"
#include <string.h>
#include "mystring.h"

class string: public vector<char>
{
    public:
     inline string::string(char* c=""):vector<char>(strlen(c)+1)
      {strcpy(t,c);max_el=strlen(c);};
     inline string::string(int c):vector<char>(5)
      {t[0]=(char) c;max_el=1;};
     inline string::string(const string &c):vector<char>(strlen(c.t)+1)
      {strcpy(t,c.t);max_el=strlen(c.t);};
     void print() const {printf("%s\n",t);};
     char* get() const {return t;};
     operator char*() const {return t;};
     inline string& operator=(const string& c)
      {int w=strlen(c.t)+1;if(w>dim)expand(w);
       strcpy(t,c.t);max_el=w;return (*this);};
     inline string& operator=(const char* c)
      {if (c==NULL) {Empty();return (*this);}
	   int w=strlen(c)+1;if(w>dim)expand(w);
       strcpy(t,c);max_el=w;return (*this);};
     inline short operator==(const string& c)const
      {return (strcmp(t,c.t)==0);};
     inline short operator!=(const string& c)const
      {return (strcmp(t,c.t)!=0);};
     inline short operator==(const char* c)const
      {return (strcmp(t,c)==0);};
     inline short operator!=(const char*  c)const
      {return (strcmp(t,c)!=0);};
     inline short operator>=(const string& c)const
      {return (strcmp(t,c.t)>=0);};
     inline short operator<=(const string& c)const
      {return (strcmp(t,c.t)<=0);};
     inline short operator>(const string& c)const
      {return (strcmp(t,c.t)>0);};
     inline short operator<(const string& c)const
      {return (strcmp(t,c.t)<0);};
     string& operator+=(const char* const c)
      {int y=strlen(t);int w=strlen(c)+y;
       if(w>=dim)expand(w);
       strcpy(t+y,c);
       max_el=w;
       return (*this);};
     string& operator+=(const char c)
      {int y=strlen(t);int w=1+y;
       if(w>=dim)expand(w);
       (t+y)[0]=c;
       (t+y)[1]='\0';
       max_el=w;
       return (*this);};
     inline string operator+(const string& c)const
      {string k=this->t;
       return (k+=c).t;};
     inline void Empty(){t[0]='\0';max_el=0;};
     inline int GetLength() {return strlen(t);;}
	 inline string &TrimLeft();
	 inline const char* Left(int i);
	 inline string &MakeLower();
	 inline string &MakeUpper();
};

inline string &string::TrimLeft()
{
	int i,n=0,l=strlen(t);
	for (i=0;i<l;i++)
	{if(t[i]==' '||t[i]=='\t') n++; else break;}
	if(n==0) return *this;
	for(i=0;i<=l-n;i++)
		t[i]=t[i+n];
	max_el=strlen(t)-1;
	return *this;
}

inline const char* string::Left(int i)
{
	int ii,n=dim,l=strlen(t);
	if (int(dim-strlen(t))<=(int)(i+3))
		expand(dim+i+5);
	for (ii=0;ii<i;ii++)
	{
		t[strlen(t)+2+ii]=t[ii];
	}
	t[strlen(t)+2+i]='\0';
	return t+strlen(t)+2;
}

inline string &string::MakeLower()
{
	strmin(t);
	return *this;
}

inline string &string::MakeUpper()
{
	strmai(t);
	return *this;
}

#endif
